import * as i0 from '@angular/core';
import { Injectable, Optional, Inject, NgModule } from '@angular/core';
import { HTTP_INTERCEPTORS } from '@angular/common/http';
import { correlationId } from 'simple-correlation-id';

const CONFIG_OPTION = 'CONFIG_OPTION';
const DEFAULT_HEADER = 'x-correlation-id';

class CorrelationIdInterceptor {
    constructor(options = '') {
        this.options = options;
    }
    intercept(request, next) {
        let cid = correlationId();
        let header = DEFAULT_HEADER;
        if (typeof this.options === 'string') {
            const system = this.options;
            cid = correlationId(system);
        }
        else if (Array.isArray(this.options)) {
            const system = this.options[0];
            header = this.options[1];
            cid = correlationId(system);
        }
        else if (this.options !== null) {
            const system = this.options.system;
            header = this.options.header;
            cid = correlationId(system);
        }
        const cloneReq = request.clone({
            headers: request.headers.set(header, cid)
        });
        return next.handle(cloneReq);
    }
}
CorrelationIdInterceptor.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.11", ngImport: i0, type: CorrelationIdInterceptor, deps: [{ token: CONFIG_OPTION, optional: true }], target: i0.ɵɵFactoryTarget.Injectable });
CorrelationIdInterceptor.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.2.11", ngImport: i0, type: CorrelationIdInterceptor });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.11", ngImport: i0, type: CorrelationIdInterceptor, decorators: [{
            type: Injectable
        }], ctorParameters: function () {
        return [{ type: undefined, decorators: [{
                        type: Optional
                    }, {
                        type: Inject,
                        args: [CONFIG_OPTION]
                    }] }];
    } });

class NgxCorrelationIdModule {
    static withConfig(options) {
        return {
            ngModule: NgxCorrelationIdModule,
            providers: [
                { provide: CONFIG_OPTION, useValue: options }
            ]
        };
    }
}
NgxCorrelationIdModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.11", ngImport: i0, type: NgxCorrelationIdModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgxCorrelationIdModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.11", ngImport: i0, type: NgxCorrelationIdModule });
NgxCorrelationIdModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.11", ngImport: i0, type: NgxCorrelationIdModule, providers: [
        { provide: HTTP_INTERCEPTORS, useClass: CorrelationIdInterceptor, multi: true }
    ] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.11", ngImport: i0, type: NgxCorrelationIdModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [],
                    imports: [],
                    exports: [],
                    providers: [
                        { provide: HTTP_INTERCEPTORS, useClass: CorrelationIdInterceptor, multi: true }
                    ]
                }]
        }] });

/*
 * Public API Surface of ngx-correlation-id
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgxCorrelationIdModule };
//# sourceMappingURL=ngx-correlation-id.mjs.map
